#ifndef _H_A171D4CA735AA23FA659C31A32DBCEC7_Ahbc_DCPS_H_
#define _H_A171D4CA735AA23FA659C31A32DBCEC7_Ahbc_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Ahbc_.h"


namespace mobileye_560_660_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Ahbc_TypeSupportInterface;

            typedef Ahbc_TypeSupportInterface * Ahbc_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Ahbc_TypeSupportInterface> Ahbc_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Ahbc_TypeSupportInterface> Ahbc_TypeSupportInterface_out;


            class Ahbc_DataWriter;

            typedef Ahbc_DataWriter * Ahbc_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Ahbc_DataWriter> Ahbc_DataWriter_var;
            typedef DDS_DCPSInterface_out < Ahbc_DataWriter> Ahbc_DataWriter_out;


            class Ahbc_DataReader;

            typedef Ahbc_DataReader * Ahbc_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Ahbc_DataReader> Ahbc_DataReader_var;
            typedef DDS_DCPSInterface_out < Ahbc_DataReader> Ahbc_DataReader_out;


            class Ahbc_DataReaderView;

            typedef Ahbc_DataReaderView * Ahbc_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Ahbc_DataReaderView> Ahbc_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Ahbc_DataReaderView> Ahbc_DataReaderView_out;

            struct Ahbc_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Ahbc_, struct Ahbc_Seq_uniq_> Ahbc_Seq;
            typedef DDS_DCPSSequence_var < Ahbc_Seq> Ahbc_Seq_var;
            typedef DDS_DCPSSequence_out < Ahbc_Seq> Ahbc_Seq_out;

            class  Ahbc_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Ahbc_TypeSupportInterface_ptr _ptr_type;
                typedef Ahbc_TypeSupportInterface_var _var_type;

                static Ahbc_TypeSupportInterface_ptr _duplicate (Ahbc_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Ahbc_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Ahbc_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Ahbc_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Ahbc_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Ahbc_TypeSupportInterface () {};
                ~Ahbc_TypeSupportInterface () {};
            private:
                Ahbc_TypeSupportInterface (const Ahbc_TypeSupportInterface &);
                Ahbc_TypeSupportInterface & operator = (const Ahbc_TypeSupportInterface &);
            };

            class  Ahbc_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Ahbc_DataWriter_ptr _ptr_type;
                typedef Ahbc_DataWriter_var _var_type;

                static Ahbc_DataWriter_ptr _duplicate (Ahbc_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Ahbc_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Ahbc_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Ahbc_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Ahbc_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Ahbc_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Ahbc_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Ahbc_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Ahbc_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Ahbc_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Ahbc_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Ahbc_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Ahbc_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Ahbc_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Ahbc_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Ahbc_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Ahbc_& instance_data) = 0;

            protected:
                Ahbc_DataWriter () {};
                ~Ahbc_DataWriter () {};
            private:
                Ahbc_DataWriter (const Ahbc_DataWriter &);
                Ahbc_DataWriter & operator = (const Ahbc_DataWriter &);
            };

            class  Ahbc_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Ahbc_DataReader_ptr _ptr_type;
                typedef Ahbc_DataReader_var _var_type;

                static Ahbc_DataReader_ptr _duplicate (Ahbc_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Ahbc_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Ahbc_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Ahbc_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Ahbc_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Ahbc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Ahbc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Ahbc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Ahbc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Ahbc_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Ahbc_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Ahbc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Ahbc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Ahbc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Ahbc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Ahbc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Ahbc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Ahbc_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Ahbc_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Ahbc_& instance) = 0;

            protected:
                Ahbc_DataReader () {};
                ~Ahbc_DataReader () {};
            private:
                Ahbc_DataReader (const Ahbc_DataReader &);
                Ahbc_DataReader & operator = (const Ahbc_DataReader &);
            };

            class  Ahbc_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Ahbc_DataReaderView_ptr _ptr_type;
                typedef Ahbc_DataReaderView_var _var_type;

                static Ahbc_DataReaderView_ptr _duplicate (Ahbc_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Ahbc_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Ahbc_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Ahbc_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Ahbc_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Ahbc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Ahbc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Ahbc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Ahbc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Ahbc_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Ahbc_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Ahbc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Ahbc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Ahbc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Ahbc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Ahbc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Ahbc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Ahbc_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Ahbc_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Ahbc_& instance) = 0;

            protected:
                Ahbc_DataReaderView () {};
                ~Ahbc_DataReaderView () {};
            private:
                Ahbc_DataReaderView (const Ahbc_DataReaderView &);
                Ahbc_DataReaderView & operator = (const Ahbc_DataReaderView &);
            };
        }

    }

}

#endif
