#ifndef _H_8E55AC14D23DB0893A8FF730D013A052_AwsDisplay__H_
#define _H_8E55AC14D23DB0893A8FF730D013A052_AwsDisplay__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace mobileye_560_660_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace AwsDisplay_Constants
            {
                const ::DDS::Octet SOUND_SILENT_ = 0;

                const ::DDS::Octet SOUND_LDWL_ = 1;

                const ::DDS::Octet SOUND_LDWR_ = 2;

                const ::DDS::Octet SOUND_FAR_HW_ = 3;

                const ::DDS::Octet SOUND_NEAR_HW_ = 4;

                const ::DDS::Octet SOUND_SOFT_FCW_ = 5;

                const ::DDS::Octet SOUND_HARD_FCW_ = 6;

                const ::DDS::Octet SOUND_RESERVED_ = 7;

                const ::DDS::Octet HEADWAY_LEVEL_OFF_ = 0;

                const ::DDS::Octet HEADWAY_LEVEL_GREEN_ = 1;

                const ::DDS::Octet HEADWAY_LEVEL_ORANGE_ = 2;

                const ::DDS::Octet HEADWAY_LEVEL_RED_ = 3;

            }

            struct  AwsDisplay_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Boolean suppress_sound_;
                ::DDS::Boolean night_time_;
                ::DDS::Boolean dusk_time_;
                ::DDS::Octet sound_type_;
                ::DDS::Boolean headway_valid_;
                ::DDS::Float headway_measurement_;
                ::DDS::Boolean lanes_on_;
                ::DDS::Boolean left_ldw_on_;
                ::DDS::Boolean right_ldw_on_;
                ::DDS::Boolean fcw_on_;
                ::DDS::Boolean left_crossing_;
                ::DDS::Boolean right_crossing_;
                ::DDS::Boolean maintenance_;
                ::DDS::Boolean failsafe_;
                ::DDS::Boolean ped_fcw_;
                ::DDS::Boolean ped_in_dz_;
                ::DDS::Octet headway_warning_level_;
            };

            typedef DDS_DCPSStruct_var<AwsDisplay_> AwsDisplay__var;
            typedef DDS_DCPSStruct_out < AwsDisplay_> AwsDisplay__out;

        }

    }

}

#endif /* _H_8E55AC14D23DB0893A8FF730D013A052_AwsDisplay__H_ */
