#ifndef _H_4DD041D5B8D7FC3FAD996605107E86F3_LkaLane__H_
#define _H_4DD041D5B8D7FC3FAD996605107E86F3_LkaLane__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace mobileye_560_660_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace LkaLane_Constants
            {
                const ::DDS::Octet LANE_CONFIDENCE_NONE_ = 0;

                const ::DDS::Octet LANE_CONFIDENCE_LOW_ = 1;

                const ::DDS::Octet LANE_CONFIDENCE_MED_ = 2;

                const ::DDS::Octet LANE_CONFIDENCE_HIGH_ = 3;

                const ::DDS::Octet LANE_TYPE_DASHED_ = 0;

                const ::DDS::Octet LANE_TYPE_SOLID_ = 1;

                const ::DDS::Octet LANE_TYPE_NONE_ = 2;

                const ::DDS::Octet LANE_TYPE_ROAD_EDGE_ = 3;

                const ::DDS::Octet LANE_TYPE_DOUBLE_LANE_MARK_ = 4;

                const ::DDS::Octet LANE_TYPE_BOTTS_DOTS_ = 5;

                const ::DDS::Octet LANE_TYPE_INVALID_ = 6;

            }

            struct  LkaLane_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Octet lane_type_;
                ::DDS::Octet quality_;
                ::DDS::Octet model_degree_;
                ::DDS::Double position_parameter_c0_;
                ::DDS::Double curvature_parameter_c2_;
                ::DDS::Double curvature_derivative_parameter_c3_;
                ::DDS::Float marking_width_;
                ::DDS::Double heading_angle_parameter_c1_;
                ::DDS::Float view_range_;
                ::DDS::Boolean view_range_availability_;
            };

            typedef DDS_DCPSStruct_var<LkaLane_> LkaLane__var;
            typedef DDS_DCPSStruct_out < LkaLane_> LkaLane__out;

        }

    }

}

#endif /* _H_4DD041D5B8D7FC3FAD996605107E86F3_LkaLane__H_ */
