#ifndef _H_C13B0BD65EA35349A165BFADAD998EAC_ObstacleData__H_
#define _H_C13B0BD65EA35349A165BFADAD998EAC_ObstacleData__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace mobileye_560_660_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace ObstacleData_Constants
            {
                const ::DDS::Octet BLINKER_INFO_UNAVAILABLE_ = 0;

                const ::DDS::Octet BLINKER_INFO_OFF_ = 1;

                const ::DDS::Octet BLINKER_INFO_LEFT_ = 2;

                const ::DDS::Octet BLINKER_INFO_RIGHT_ = 3;

                const ::DDS::Octet BLINKER_INFO_BOTH_ = 4;

                const ::DDS::Octet CUT_IN_AND_OUT_UNDEFINED_ = 0;

                const ::DDS::Octet CUT_IN_AND_OUT_IN_HOST_LANE_ = 1;

                const ::DDS::Octet CUT_IN_AND_OUT_OUT_HOST_LANE_ = 2;

                const ::DDS::Octet CUT_IN_AND_OUT_CUT_IN_ = 3;

                const ::DDS::Octet CUT_IN_AND_OUT_CUT_OUT_ = 4;

                const ::DDS::Octet OBSTACLE_TYPE_VEHICLE_ = 0;

                const ::DDS::Octet OBSTACLE_TYPE_TRUCK_ = 1;

                const ::DDS::Octet OBSTACLE_TYPE_BIKE_ = 2;

                const ::DDS::Octet OBSTACLE_TYPE_PED_ = 3;

                const ::DDS::Octet OBSTACLE_TYPE_BICYCLE_ = 4;

                const ::DDS::Octet OBSTACLE_STATUS_UNDEFINED_ = 0;

                const ::DDS::Octet OBSTACLE_STATUS_STANDING_ = 1;

                const ::DDS::Octet OBSTACLE_STATUS_STOPPED_ = 2;

                const ::DDS::Octet OBSTACLE_STATUS_MOVING_ = 3;

                const ::DDS::Octet OBSTACLE_STATUS_ONCOMING_ = 4;

                const ::DDS::Octet OBSTACLE_STATUS_PARKED_ = 5;

                const ::DDS::Octet OBSTACLE_VALID_INVALID_ = 0;

                const ::DDS::Octet OBSTACLE_VALID_NEW_ = 1;

                const ::DDS::Octet OBSTACLE_VALID_OLDER_ = 2;

                const ::DDS::Octet OBSTACLE_LANE_NOT_ASSIGNED_ = 0;

                const ::DDS::Octet OBSTACLE_LANE_EGO_LANE_ = 1;

                const ::DDS::Octet OBSTACLE_LANE_NEXT_LANE_ = 2;

                const ::DDS::Octet OBSTACLE_LANE_INVALID_ = 3;

                const ::DDS::Octet RADAR_MATCH_CONFIDENCE_NO_MATCH_ = 0;

                const ::DDS::Octet RADAR_MATCH_CONFIDENCE_MULTI_MATCH_ = 1;

                const ::DDS::Octet RADAR_MATCH_CONFIDENCE_BOUNDED_LOW_ = 2;

                const ::DDS::Octet RADAR_MATCH_CONFIDENCE_BOUNDED_MED_ = 3;

                const ::DDS::Octet RADAR_MATCH_CONFIDENCE_BOUNDED_HIGH_ = 4;

                const ::DDS::Octet RADAR_MATCH_CONFIDENCE_HIGH_ = 5;

            }

            struct  ObstacleData_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::UShort obstacle_id_;
                ::DDS::Double obstacle_pos_x_;
                ::DDS::Double obstacle_pos_y_;
                ::DDS::Octet blinker_info_;
                ::DDS::Octet cut_in_and_out_;
                ::DDS::Double obstacle_rel_vel_x_;
                ::DDS::Octet obstacle_type_;
                ::DDS::Octet obstacle_status_;
                ::DDS::Boolean obstacle_brake_lights_;
                ::DDS::Octet obstacle_valid_;
                ::DDS::Float obstacle_length_;
                ::DDS::Float obstacle_width_;
                ::DDS::UShort obstacle_age_;
                ::DDS::Octet obstacle_lane_;
                ::DDS::Boolean cipv_flag_;
                ::DDS::Float radar_pos_x_;
                ::DDS::Float radar_vel_x_;
                ::DDS::Octet radar_match_confidence_;
                ::DDS::UShort matched_radar_id_;
                ::DDS::Float obstacle_angle_rate_;
                ::DDS::Double obstacle_scale_change_;
                ::DDS::Float object_accel_x_;
                ::DDS::Boolean obstacle_replaced_;
                ::DDS::Float obstacle_angle_;
            };

            typedef DDS_DCPSStruct_var<ObstacleData_> ObstacleData__var;
            typedef DDS_DCPSStruct_out < ObstacleData_> ObstacleData__out;

        }

    }

}

#endif /* _H_C13B0BD65EA35349A165BFADAD998EAC_ObstacleData__H_ */
