#ifndef _H_42755477CAD6ED734845D245458F61CF_Tsr_DCPS_H_
#define _H_42755477CAD6ED734845D245458F61CF_Tsr_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Tsr_.h"


namespace mobileye_560_660_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Tsr_TypeSupportInterface;

            typedef Tsr_TypeSupportInterface * Tsr_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Tsr_TypeSupportInterface> Tsr_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Tsr_TypeSupportInterface> Tsr_TypeSupportInterface_out;


            class Tsr_DataWriter;

            typedef Tsr_DataWriter * Tsr_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Tsr_DataWriter> Tsr_DataWriter_var;
            typedef DDS_DCPSInterface_out < Tsr_DataWriter> Tsr_DataWriter_out;


            class Tsr_DataReader;

            typedef Tsr_DataReader * Tsr_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Tsr_DataReader> Tsr_DataReader_var;
            typedef DDS_DCPSInterface_out < Tsr_DataReader> Tsr_DataReader_out;


            class Tsr_DataReaderView;

            typedef Tsr_DataReaderView * Tsr_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Tsr_DataReaderView> Tsr_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Tsr_DataReaderView> Tsr_DataReaderView_out;

            struct Tsr_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Tsr_, struct Tsr_Seq_uniq_> Tsr_Seq;
            typedef DDS_DCPSSequence_var < Tsr_Seq> Tsr_Seq_var;
            typedef DDS_DCPSSequence_out < Tsr_Seq> Tsr_Seq_out;

            class  Tsr_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Tsr_TypeSupportInterface_ptr _ptr_type;
                typedef Tsr_TypeSupportInterface_var _var_type;

                static Tsr_TypeSupportInterface_ptr _duplicate (Tsr_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Tsr_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Tsr_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Tsr_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Tsr_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Tsr_TypeSupportInterface () {};
                ~Tsr_TypeSupportInterface () {};
            private:
                Tsr_TypeSupportInterface (const Tsr_TypeSupportInterface &);
                Tsr_TypeSupportInterface & operator = (const Tsr_TypeSupportInterface &);
            };

            class  Tsr_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Tsr_DataWriter_ptr _ptr_type;
                typedef Tsr_DataWriter_var _var_type;

                static Tsr_DataWriter_ptr _duplicate (Tsr_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Tsr_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Tsr_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Tsr_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Tsr_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Tsr_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Tsr_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Tsr_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Tsr_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Tsr_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Tsr_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Tsr_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Tsr_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Tsr_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Tsr_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Tsr_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Tsr_& instance_data) = 0;

            protected:
                Tsr_DataWriter () {};
                ~Tsr_DataWriter () {};
            private:
                Tsr_DataWriter (const Tsr_DataWriter &);
                Tsr_DataWriter & operator = (const Tsr_DataWriter &);
            };

            class  Tsr_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Tsr_DataReader_ptr _ptr_type;
                typedef Tsr_DataReader_var _var_type;

                static Tsr_DataReader_ptr _duplicate (Tsr_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Tsr_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Tsr_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Tsr_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Tsr_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Tsr_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Tsr_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Tsr_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Tsr_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Tsr_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Tsr_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Tsr_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Tsr_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Tsr_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Tsr_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Tsr_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Tsr_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Tsr_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Tsr_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Tsr_& instance) = 0;

            protected:
                Tsr_DataReader () {};
                ~Tsr_DataReader () {};
            private:
                Tsr_DataReader (const Tsr_DataReader &);
                Tsr_DataReader & operator = (const Tsr_DataReader &);
            };

            class  Tsr_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Tsr_DataReaderView_ptr _ptr_type;
                typedef Tsr_DataReaderView_var _var_type;

                static Tsr_DataReaderView_ptr _duplicate (Tsr_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Tsr_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Tsr_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Tsr_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Tsr_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Tsr_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Tsr_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Tsr_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Tsr_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Tsr_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Tsr_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Tsr_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Tsr_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Tsr_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Tsr_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Tsr_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Tsr_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Tsr_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Tsr_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Tsr_& instance) = 0;

            protected:
                Tsr_DataReaderView () {};
                ~Tsr_DataReaderView () {};
            private:
                Tsr_DataReaderView (const Tsr_DataReaderView &);
                Tsr_DataReaderView & operator = (const Tsr_DataReaderView &);
            };
        }

    }

}

#endif
